package de.donmanfred;

import java.util.Arrays;
import java.util.List;

import com.firebase.ui.auth.AuthUI;
import com.firebase.ui.auth.AuthUI.IdpConfig;
import com.firebase.ui.auth.AuthUI.SignInIntentBuilder;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;

@BA.ShortName("SignInIntentBuilder")
public class SignInIntentBuilderWrapper extends AbsObjectWrapper<SignInIntentBuilder> {
	private String eventName;
	private List<IdpConfig> providers = new java.util.ArrayList<IdpConfig>();
	public SignInIntentBuilderWrapper() {
	}
	public void Initialize(BA ba, String EventName, SignInIntentBuilder builder, String defaultclient) {
		eventName = EventName.toLowerCase(BA.cul);
		SharedPreferences sharedpreferences = ba.context.getSharedPreferences("DefaultWebClient", Context.MODE_PRIVATE);

    SharedPreferences.Editor editor = sharedpreferences.edit();
    editor.putString("DfaultWebClient", defaultclient);
    editor.commit();

		
		setObject(builder);
	}
	public void clearProvider(){
		providers.clear();
	}
	public void addProvider(IdpConfig provider){
		providers.add(provider);
	}
	public List<IdpConfig> getProviderlist(){
		return providers;
	}
	public IdpConfig getIdpEMAIL_PROVIDER(){
		return new AuthUI.IdpConfig.EmailBuilder().build();
	}
	public IdpConfig getIdpFACEBOOK_PROVIDER(){
		return new AuthUI.IdpConfig.FacebookBuilder().build();
	}
	//"https://www.googleapis.com/auth/firebase"
	/**
	 * 
	 * @return
	 */
	public IdpConfig getIdpGOOGLE_PROVIDER(){
		return new AuthUI.IdpConfig.GoogleBuilder().setScopes(java.util.Arrays.asList("https://www.googleapis.com/auth/firebase","https://www.googleapis.com/auth/cloud-platform", "https://www.googleapis.com/auth/datastore")).build();
	}
	
	// String[] myArra
	public IdpConfig GetIdpGOOGLE_PROVIDER2(String[] scopes){
		//return new AuthUI.IdpConfig.GoogleBuilder().setScopes(Arrays.asList(scopes)).build();
		return new AuthUI.IdpConfig.GoogleBuilder().setScopes(Arrays.asList(scopes)).build();
	}
	public IdpConfig GetIdpGOOGLE_PROVIDER3(){
		//return new AuthUI.IdpConfig.GoogleBuilder().setScopes(Arrays.asList(scopes)).build();
		return new AuthUI.IdpConfig.GoogleBuilder().build();
	}
	public IdpConfig getIdpANONYMOUS_PROVIDER(){
		return new AuthUI.IdpConfig.AnonymousBuilder().build();
	}
	public IdpConfig getIdpGITHUB_PROVIDER(){
		return new AuthUI.IdpConfig.GitHubBuilder().build();
	}
	public IdpConfig getIdpPHONE_VERIFICATION_PROVIDER(){
		return new AuthUI.IdpConfig.PhoneBuilder().build();
	}
	public IdpConfig getIdpTWITTER_PROVIDER(){
		return new AuthUI.IdpConfig.TwitterBuilder().build();
	}
	public SignInIntentBuilderWrapper setAvailableProviders(List<IdpConfig> providers){
		getObject().setAvailableProviders(providers);
		return this;
	}
	public SignInIntentBuilderWrapper setIsSmartLockEnabled(boolean enabled){
		getObject().setIsSmartLockEnabled(enabled);
		return this;
	}
	public SignInIntentBuilderWrapper setIsSmartLockEnabled2(boolean enableCredentials, boolean enableHints){
		getObject().setIsSmartLockEnabled(enableCredentials, enableHints);
		return this;
	}
	public SignInIntentBuilderWrapper setLogo(int logo){
		getObject().setLogo(logo);
		return this;
	}
	public SignInIntentBuilderWrapper setAlwaysShowSignInMethodScreen(boolean alwaysShow){
		getObject().setAlwaysShowSignInMethodScreen(alwaysShow);
		return this;
	}
	public SignInIntentBuilderWrapper setEmailLink(String emailLink){
		getObject().setEmailLink(emailLink);
		return this;
	}
	public SignInIntentBuilderWrapper setPrivacyPolicyUrl(String privacyPolicyUrl){
		getObject().setPrivacyPolicyUrl(privacyPolicyUrl);
		return this;
	}

	public SignInIntentBuilderWrapper setTheme(int theme){
		getObject().setTheme(theme);
		return this;
	}
	public SignInIntentBuilderWrapper setTosUrl(String tosUrl){
		getObject().setTosUrl(tosUrl);
		return this;
	}
	public Intent build(){
		return getObject().build();
	}

}
